#include "./USB/usb.h"              // https://dl.dropboxusercontent.com/u/101922388/WiflySanUSB.zip
#include "./USB/usb_function_cdc.h" // Videos: https://www.youtube.com/watch?v=bN7zj7BQXnE
#include "HardwareProfile.h"        // APK: https://play.google.com/store/apps/details?id=appinventor.ai_sandro_juca.Wifi_SanUSB
                                    // http://www.youtube.com/watch?v=gUe24X1gNVw
/** I N C L U D E S **********************************************************/
#include "SanUSB48.h"
#include "GenericTypeDefs.h"
#include "Compiler.h"
#include "usb_config.h"
#include "USB/usb_device.h"
#include "USB/usb.h"
#include "HardwareProfile.h"

/** V A R I A B L E S ********************************************************/
/***After uploading or reset, wait until only the green led on the Wifly modem is blinking and click connect on the front-end.
 /***Após o upload ou reset, aguarde ate que somente o led verde do modem Wifly esteja piscando e clique em conectar no front-end***/
//Apos gravar o microcontrolador com o modem Wifly conectado (Vcc(3,3V), Gnd, Tx, Rx)
#pragma udata

char rede[] = "SanUSB";       // Your WiFi SSID name up to 12 characters
char senha[] = "Laese";       // Your WiFi password
char ip[] = "192.168.1.195";  // Set intranet static IP (DHCP OFF). In this the case static IP .195 is based on the IP gateway 192.168.1.1.
                              // To check the IP of your gateway type ipconfig at the prompt or terminal on the computer 
                              // Default Wifly RN-XV SanUSB: 192.168.1.195 Port: 80.

short int pisca=0, AT1=0,  AT2=0, start=0;
char  comando[30], n=0, m=0, k=0;
//unsigned char comando;

char USB_In_Buffer[64];
char USB_Out_Buffer[64];
char zan=0, pos=0;
short int flag=0;

BOOL stringPrinted;
volatile BOOL buttonPressed;
volatile BYTE buttonCount;

/** P R I V A T E  P R O T O T Y P E S ***************************************/
static void InitializeSystem(void);
void ProcessIO(void);
void USBDeviceTasks(void);
void YourHighPriorityISRCode();
void YourLowPriorityISRCode();
void USBCBSendResume(void);
void BlinkUSBStatus(void);
void UserInit(void);

#pragma interrupt interrupcao //Tem que estar aqui ou dentro do firmware.c
void interrupcao(){
if (serial_interrompeu)  {
     serial_interrompeu=0;
     comando[n] = le_serial(); m=n; //comand[m]=comando[n];

         switch (comando[n]){

             case 'C':
             AT1=1;
             break;

             case 'I':
             AT2=1;
             break;

             case 'A':
             AT1=1;
             break;

             case 'S':
             AT1=1;
             break;

             case '*':
             AT1=1;
             break;
           case 'Y':
             {n=0;comando[0] = 'Y';}
              break;
         }
 //***************possibility 1->character***********************
                            if (comando[0]== 'Y' && n==1){comando[0]== 32;
                                       switch(RCREG)
                                                  {
                                                case 'L':  nivel_alto(pin_b7);
                                                break;

                                                case 'D': nivel_baixo(pin_b7);
                                                break;

                                                case 'P':  nivel_alto(pin_b0);
                                                break;

                                                case 'T': nivel_baixo(pin_b0);
                                                break;

                                                 }
                                                         }
//***************possibility 2-> word**************************
                            if ( comando[1]== 'O' && comando[2]== 'N')
                                                {
                                                 nivel_alto(pin_b7);  // ON
                                                }

                            if ( comando[1]== 'O' && comando[2]== 'F' && comando[3]== 'F')
                                                {

                                                 nivel_baixo(pin_b7); // OFF
                                                }
 //*/
         ++n; if(n>=30){n=0;}
   }
        #if defined(USB_INTERRUPT)
           USBDeviceTasks();
        #endif

                   }   

#include "confws.h"

void main(void)
{
    clock_int_48MHz();
    habilita_interrupcao(recep_serial);
    taxa_serial(9600);
    iniws();
    InitializeSystem();
    habilita_wdt();

    while(1)
    {   ClrWdt();
        #if defined(USB_INTERRUPT)
            if(USB_BUS_SENSE && (USBGetDeviceState() == DETACHED_STATE))
            {
                USBDeviceAttach();
            }
        #endif

        #if defined(USB_POLLING)

        #endif
 // Application related code may be added here, or in the ProcessIO() function.
        ProcessIO();
    }//end while
}//end main

 //***Depura caracteres da serial real e da porta serial emulada via USB***/
void ProcessIO(void)
{

   if((USBDeviceState < CONFIGURED_STATE)||(USBSuspendControl==1)) return;

   //*******************************************************************
             if(USBUSARTIsTxTrfReady())
           {
        char ch[2];            //two bytes, the second is always null
        char san_ch[1];      //used for receiving from the SIE
        ch[1] = 0x00;      //the second is always null
             if(PIR1bits.RCIF)         //byte on USART
                        {
          PIR1bits.RCIF = 0;   //reset interrupt flag
             ch[0] = RCREG;    //exemplo: IP:Porta/Ycomando -> 192.168.1.195:80/YL
                               if(RCREG== 'Y'){ n=0; }
                               comando[n] = RCREG;
                            //***************possibility 1->character***********************
                            if (comando[0]== 'Y' && n==1){comando[0]== 32;
                                       switch(RCREG)
                                                  {
                                                case 'L':  nivel_alto(pin_b7);
                                                break;

                                                case 'D': nivel_baixo(pin_b7);
                                                break;

                                                case 'P':  nivel_alto(pin_b0);
                                                break;

                                                case 'T': nivel_baixo(pin_b0);
                                                break;

                                                 }
                                                         }

                               //***************possibility 2-> word**************************
                            if ( comando[1]== 'O' && comando[2]== 'N')
                                                {
                                                 nivel_alto(pin_b7);  // ON
                                                }

                            if ( comando[1]== 'O' && comando[2]== 'F' && comando[3]== 'F')
                                                {

                                                 nivel_baixo(pin_b7); // OFF
                                                }
                              //*************************************************************

                                putsUSBUSART(ch); //transmit on CDC
                                ++n; if(n>=30){n=0;}
                }


      if(getsUSBUSART(san_ch,1))              //byte on SIE
         {
            ch[0] = san_ch[0];
                                         switch(san_ch[0])
                                            {
                                             case 'L': nivel_alto(pin_b7); //Enviado pelo teclado
                                            //putrsUSBUSART("SanUSB ");
                                             break;

                                             case 'D' : nivel_baixo(pin_b7);
                                             break;

                                             case 114 : ch[0]=ch[1];
                                             break;

                                             case 115 : ch[0]=ch[1];
                                             break;
                                             }
            putcUSART(ch[0]);   //transmit on USART

         }


                }

    CDCTxService();
} //end ProcessIO

static void InitializeSystem(void)
{
    //PIE1bits.RCIE = 0; //serial selbstaendig (PIE1bits.RCIE=1->interrupt) oder CDC-USB(PIE1bits.RCIE=0) Verbindung
    //IPR1bits.RCIP = 0; //Para serial real remoto, comentar RCIE e RCIP
    ADCON1 |= 0x0F;                 // Default all pins to digital
    _asm
    MOVLW 0b11111101
    MOVWF EEADR, 0
    bcf EECON1,7,0
    bcf EECON1,6,0
    bsf EECON1,0,0
    BLEIBEN:
    BTFSC EEDATA,0,0
    goto BLEIBEN
_endasm
    UserInit();
    USBDeviceInit();
}//end InitializeSystem


void UserInit(void)
{
    //Initialize all of the debouncing variables
    buttonCount = 0;
    buttonPressed = FALSE;
    stringPrinted = TRUE;

    //Initialize all of the LED pins
   mInitAllLEDs();

    //Initialize the pushbuttons
    mInitAllSwitches();
}//end UserInit


void USBCBSuspend(void)
{

}


void USBCBWakeFromSuspend(void)
{

}

void USBCB_SOF_Handler(void)
{
    // No need to clear UIRbits.SOFIF to 0 here.
    // Callback caller is already doing that.

    //This is reverse logic since the pushbutton is active low
    if(buttonPressed == sw2)
    {
        if(buttonCount != 0)
        {
            buttonCount--;
        }
        else
        {
            //This is reverse logic since the pushbutton is active low
            buttonPressed = !sw2;

            //Wait 100ms before the next press can be generated
            buttonCount = 100;
        }
    }
    else
    {
        if(buttonCount != 0)
        {
            buttonCount--;
        }
    }
}


void USBCBErrorHandler(void)
{

}


void USBCBCheckOtherReq(void)
{
    USBCheckCDCRequest();
}//end

void USBCBStdSetDscHandler(void)
{
    // Must claim session ownership if supporting this request
}//end



void USBCBInitEP(void)
{
    //Enable the CDC data endpoints
    CDCInitEP();
}

void USBCBSendResume(void)
{
    static WORD delay_count;


    if(USBGetRemoteWakeupStatus() == TRUE)
    {
        //Verify that the USB bus is in fact suspended, before we send
        //remote wakeup signalling.
        if(USBIsBusSuspended() == TRUE)
        {
            USBMaskInterrupts();

            //Clock switch to settings consistent with normal USB operation.
            USBCBWakeFromSuspend();
            USBSuspendControl = 0;
            USBBusIsSuspended = FALSE;  //So we don't execute this code again,
                                        //until a new suspend condition is detected.

            delay_count = 3600U;
            do
            {
                delay_count--;
            }while(delay_count);

            //Now drive the resume K-state signalling onto the USB bus.
            USBResumeControl = 1;       // Start RESUME signaling
            delay_count = 1800U;        // Set RESUME line for 1-13 ms
            do
            {
                delay_count--;
            }while(delay_count);
            USBResumeControl = 0;       //Finished driving resume signalling

            USBUnmaskInterrupts();
        }
    }
}


#if defined(ENABLE_EP0_DATA_RECEIVED_CALLBACK)
void USBCBEP0DataReceived(void)
{
}
#endif


BOOL USER_USB_CALLBACK_EVENT_HANDLER(int event, void *pdata, WORD size)
{
    switch( event )
    {
        case EVENT_TRANSFER:
            //Add application specific callback task or callback function here if desired.
            break;
        case EVENT_SOF:
            USBCB_SOF_Handler();
            break;
        case EVENT_SUSPEND:
            USBCBSuspend();
            break;
        case EVENT_RESUME:
            USBCBWakeFromSuspend();
            break;
        case EVENT_CONFIGURED:
            USBCBInitEP();
            break;
        case EVENT_SET_DESCRIPTOR:
            USBCBStdSetDscHandler();
            break;
        case EVENT_EP0_REQUEST:
            USBCBCheckOtherReq();
            break;
        case EVENT_BUS_ERROR:
            USBCBErrorHandler();
            break;
        case EVENT_TRANSFER_TERMINATED:

            break;
        default:
            break;
    }
    return TRUE;
}


/** EOF main.c *************************************************/
